SystemOrganization addCategory: #'Athens-Morphic'!

PluggableTextMorph subclass: #AthensPluggableTextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Morphic'!

!AthensPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 12:01'!
textMorphClass
	^ AthensTextMorph! !

!LazyListMorph methodsFor: '*Athens-Morphic' stamp: 'IgorStasenko 10/4/2011 16:49'!
athensDisplay: item atRow: row on: aCanvas 
	"Display the given item at the given row on the given
	canvas."
	
	| c drawBounds frame attrs useDefaultFont |
	drawBounds := self drawBoundsForRow: row.
	c := self colorForRow: row.
	aCanvas
		drawString: item asString
		in: drawBounds
		font: self font
		color: (self colorForRow: row)! !

!LazyListMorph methodsFor: '*Athens-Morphic' stamp: 'IgorStasenko 10/4/2011 16:50'!
athensDrawSelectionOn: anAthensCanvas 
	
self value! !

!LazyListMorph methodsFor: '*Athens-Morphic' stamp: 'IgorStasenko 12/21/2011 13:56'!
drawOnAthensCanvas: aCanvas


	aCanvas setPaint: Color green.
	aCanvas drawShape: self bounds.
	
	listItems size = 0
		ifTrue: [^ self].
		
	"self drawSelectionOn: aCanvas."
	1 to: listItems size do: [:row |
		(listSource itemSelectedAmongMultiple: row)
			ifTrue: [ self athensDrawBackgroundForSelectedRow: row on: aCanvas]
			ifFalse: [
				(listSource searchedElement = row)
					ifTrue: [ self athensDrawBackgroundForSearchedRow: row on: aCanvas]
					ifFalse: [
						(listSource backgroundColorFor: row)
							ifNotNil: [:col |
								self athensDrawBackgroundForRow: row on: aCanvas color: col ]]].
					
			selectedRow = row ifTrue: [ self athensDrawSelectionOn: aCanvas ].
			(listSource separatorAfterARow: row) ifTrue: [ self athensDrawSeparatorAfter: row on: aCanvas ].
			self
				athensDisplay: (self item: row)
				atRow: row
				on: aCanvas].
		
	listSource potentialDropRow > 0
		ifTrue: [self athensHighlightPotentialDropRow: listSource potentialDropRow on: aCanvas]! !

!Morph methodsFor: '*Athens-Morphic' stamp: 'IgorStasenko 9/2/2012 21:39'!
drawOnAthensCanvas: anAthensCanvas 

	anAthensCanvas setPaint: self fillStyle.
	anAthensCanvas drawShape: self bounds.! !

!Morph methodsFor: '*Athens-Morphic' stamp: 'IgorStasenko 9/2/2012 21:44'!
fullDrawOnAthensCanvas: anAthensCanvas 
	"Draw the full Morphic structure on the given Canvas"

	self visible ifFalse: [^ self].
	(anAthensCanvas isVisible: self fullBounds) ifFalse: [^self].
	(self hasProperty: #errorOnDraw) ifTrue: [^self "drawErrorOn: aCanvas" ].

	(anAthensCanvas isVisible: self bounds) ifTrue: [ anAthensCanvas draw: self ].
	
	submorphs isEmpty ifTrue: [^self].

	self clipSubmorphs ifTrue: [ | clip |
		clip := self clippingBounds.
		anAthensCanvas 
			clipBy: clip
			during: [
				submorphs reverseDo: [:m | anAthensCanvas fullDrawMorph: m ] 
			]
	] 
	ifFalse: [
		submorphs reverseDo: [:m | anAthensCanvas fullDrawMorph: m ]
	]
! !

!PasteUpMorph methodsFor: '*Athens-Morphic' stamp: 'IgorStasenko 4/21/2011 14:33'!
drawOnAthensCanvas: aCanvas 
	"Draw in order:
	- background color
	- background sketch, if any
	- Update and draw the turtleTrails form. See the comment in updateTrailsForm.

	Later (in drawSubmorphsOn:) I will skip drawing the background sketch."

	"draw background fill"
	super drawOnAthensCanvas: aCanvas.

	backgroundMorph ifNotNil: [
		aCanvas clipBy: self clippingBounds
			during: [ aCanvas fullDrawMorph: backgroundMorph ]
	]				
! !

!TextMorph methodsFor: '*Athens-Morphic' stamp: 'IgorStasenko 3/8/2012 14:02'!
drawOnAthensCanvas: aCanvas

	"Draw the receiver on a canvas.
	Draw keyboard focus if appropriate."

	| fauxBounds |

	self setDefaultContentsIfNil.
	super drawOnAthensCanvas: aCanvas.  "Border and background if any"
	
	"nothing to draw?"
	(self startingIndex > text size)
		ifTrue: [ ^ self ].

	"Hack here:  The canvas expects bounds to carry the location of the text, but we also need to communicate clipping."
	fauxBounds := self bounds topLeft corner: self innerBounds bottomRight.
	
	self paragraph drawOnAthensCanvas: aCanvas bounds: fauxBounds.
	
	! !

!TransformMorph methodsFor: '*Athens-Morphic' stamp: 'IgorStasenko 9/2/2012 21:55'!
fullDrawOnAthensCanvas: anAthensCanvas 
	"Draw the full Morphic structure on the given Canvas"

	self visible ifFalse: [^ self].
	(anAthensCanvas isVisible: self fullBounds) ifFalse: [^self].
	(self hasProperty: #errorOnDraw) ifTrue: [^self "drawErrorOn: aCanvas" ].

	(anAthensCanvas isVisible: self bounds) ifTrue: [ anAthensCanvas draw: self ].
	
	submorphs isEmpty ifTrue: [^self].

	self clipSubmorphs ifTrue: [ | clip p1 p2 |
		clip := self clippingBounds.
		anAthensCanvas 
			clipBy: clip 
			during: [ 
				anAthensCanvas pathTransform restoreAfter: [
					anAthensCanvas pathTransform translateBy: self transform offset negated.
					submorphs reverseDo: [:m | anAthensCanvas fullDrawMorph: m ] ].
		].

	] 
	ifFalse: [
		submorphs reverseDo: [:m | anAthensCanvas fullDrawMorph: m ]
	]
! !

!ImageMorph methodsFor: '*Athens-Morphic' stamp: 'IgorStasenko 3/8/2012 13:39'!
drawOnAthensCanvas: aCanvas

	aCanvas setPaint: image.
	aCanvas drawShape: self innerBounds.! !

TextMorphForEditView subclass: #AthensTextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Morphic'!

!AthensTextMorph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 12:42'!
contents: stringOrText wrappedTo: width
	"Accept new text contents.  Lay it out, wrapping to width.
	Then fit my height to the result."
	wrapFlag := true.
	super extent: width truncated@self height.
	self newContents: stringOrText! !

!AthensTextMorph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 12:23'!
createParagraph
	| newParagraph |
	self setDefaultContentsIfNil.

	"...Code here to recreate the paragraph..."
	newParagraph  := AthensParagraph new.
	
	newParagraph
		compose: text
		style: textStyle copy
		in: self container.
		
		
	wrapFlag ifFalse:
		["Was given huge container at first... now adjust"
		newParagraph adjustRightX].
	
	newParagraph focused: (self currentHand keyboardFocus == self).
	
	paragraph := newParagraph.
	self fit.

	^ paragraph! !

!AthensTextMorph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 12:18'!
paragraph
	^ paragraph ifNil: [ paragraph := self createParagraph ].
! !

!AthensTextMorph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 13:02'!
selectionColor: aColor
	selectionColor := aColor.
	! !

Object subclass: #AthensGeometricalHierarchy
	instanceVariableNames: 'geometry currentMorph stack history'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Morphic'!

!AthensGeometricalHierarchy methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/31/2012 22:42'!
initialize
	geometry := WeakIdentityKeyDictionary new.
	stack := OrderedCollection new: 100.! !

!AthensGeometricalHierarchy methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/31/2012 23:02'!
newStory

	history := OrderedCollection new: 1000.! !

!AthensGeometricalHierarchy methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/31/2012 23:03'!
pop
	| doneMorph |
	doneMorph := stack removeLast.
	history add: doneMorph.
	currentMorph := stack ifEmpty: [ nil ] ifNotEmpty: [ stack last ].! !

!AthensGeometricalHierarchy methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/31/2012 22:44'!
push: aMorph
	currentMorph := aMorph.
	stack addLast: aMorph.! !

!AthensGeometricalHierarchy methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/31/2012 22:50'!
registerShape: aShape canvas: aCanvas

	| infos info |
	infos := geometry at: currentMorph ifAbsentPut: [ OrderedCollection new ].

	info := 
	AthensVisualInfo new
		shape: aShape;
		clipRect: aCanvas clipRect;
		transform: aCanvas pathTransform getMatrix.
		
	infos add: info! !

!AthensGeometricalHierarchy methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/31/2012 22:57'!
withMorph: aMorph do: aBlock
	
	self push: aMorph.
	
	"clear geometry for incoming morph"
	geometry removeKey: aMorph ifAbsent: nil.

	[aBlock value ] ensure: [	self pop ]! !

Object subclass: #AthensParagraph
	instanceVariableNames: 'text textStyle containerRect lines positionWhenComposed selectionStart selectionStop'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Morphic'!

!AthensParagraph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/31/2012 01:31'!
caretRect ^ (0@0 corner: 0@0)  ! !

!AthensParagraph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 16:08'!
characterBlockForIndex: index 

		^ self defaultCharacterBlock! !

!AthensParagraph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 12:22'!
compose: aText style: aTextStyle from: startingIndex in: aRectangle 
	text := aText.
	textStyle := aTextStyle
	
	self shouldBeImplemented.! !

!AthensParagraph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 12:50'!
compose: aText style: aTextStyle in: rect 

	text := aText.
	textStyle := aTextStyle.
	containerRect := rect.
	lines := (AthensTextComposer scan: aText for: AthensTextScanner new) lines.! !

!AthensParagraph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 13:04'!
defaultCharacterBlock
	^ (CharacterBlock new stringIndex: 1 text: text
			topLeft: 0@0 extent: 0 @ 0)
		textLine: lines first! !

!AthensParagraph methodsFor: 'drawing' stamp: 'IgorStasenko 9/2/2012 22:21'!
drawOnAthensCanvas: canvas bounds: aRectangle 

	| renderer |
	"self halt."
	canvas
		clipBy: aRectangle 
		during: [  
			renderer := AthensTextRenderer new.
			renderer render: text lines: lines on: canvas.
		].
! !

!AthensParagraph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 12:48'!
extent
	^ containerRect width @ lines last bottom! !

!AthensParagraph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 13:07'!
extraSelectionChanged
"
	refreshExtraSelection := true
"

	self flag: #foo! !

!AthensParagraph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 13:06'!
findReplaceSelectionRegex: aRegex
"	findReplaceSelectionRegex := aRegex. "
	self flag: #foo
! !

!AthensParagraph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/31/2012 01:28'!
focused ^ false! !

!AthensParagraph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 12:45'!
focused: bool

	"why we should care?"
	
	"self flag: #ooo"! !

!AthensParagraph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 13:00'!
positionWhenComposed: pos
	positionWhenComposed := pos! !

!AthensParagraph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 13:06'!
secondarySelection: aSubString
"	secondarySelection := aSubString."
	self flag: #foo.! !

!AthensParagraph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 13:02'!
selectionColor: anUndefinedObject 
	self shouldBeImplemented.! !

!AthensParagraph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 13:08'!
selectionRects
	^ #()! !

!AthensParagraph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 13:09'!
selectionStart: startBlock selectionStop: stopBlock
	selectionStart := startBlock.
	selectionStop := stopBlock.! !

!AthensParagraph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/31/2012 01:28'!
showCared ! !

!AthensParagraph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/31/2012 01:29'!
showCaret  ! !

!AthensParagraph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/31/2012 01:29'!
showCaret: abool  ! !

!AthensParagraph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 13:05'!
text
	^ text! !

!AthensParagraph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 12:20'!
textOwner: anUndefinedObject 
	self shouldBeImplemented.! !

Object subclass: #AthensVisualInfo
	instanceVariableNames: 'clipBox shape matrix children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Morphic'!

!LabelMorph methodsFor: '*Athens-Morphic' stamp: 'IgorStasenko 8/31/2012 12:58'!
drawOnAthensCanvas: aCanvas
	"Draw based on enablement."
	
	|pc|
	pc := self owner
		ifNil: [self paneColor]
		ifNotNil: [self owner color isTransparent
					ifTrue: [self owner paneColor]
					ifFalse: [self owner color]].
	
	aCanvas pathTransform restoreAfter: [
		"aCanvas setPaint: Color blue;
			drawShape: (self bounds).
		"
		aCanvas pathTransform translateX: self left Y:
			self top + self fontToUse ascent.

		aCanvas 
			setFont: self fontToUse;
			setPaint: (self enabled ifTrue: [ self color ] ifFalse: [ pc muchDarker ] );
			drawString: self contents.
	]! !
